#!/usr/bin/perl

#----------------------------------------------------------------------
#                                qdpop.pl
#      qdpop.pl is a PERL script which uses Sean Dowd's POP3Client
# module to access a POP3 account and retrieve header information, and
# Perl Sendmail, Version 1.21, by Christian Mallwitz.
#
# QD-POP 2.0: Quick and Dirty POP mail cgi client.
# Copyright (c) 1997 David B. Hill, MD (dbhill@ucdavis.edu)
#                        and
#                  Michael Hogarth, MD (mahogarth@ucdavis.edu)
# Copying terms: GNU General Public License
# Credits: Sean Dowd <ssd@mmts.eds.com> for POP3Client
#          Lincoln D. Stein <stein@genome.wi.mit.edu> for CGI.PM
#		   Christian Mallwitz, Germany, for Perl Sendmail Version 1.21 
#
#----------------------------------------------------------------------
#Version 2.0 alpha, December 97
#	Reversed display order to put most recent first
#	limited fetches to 10 headers at a time
#	Added display date to headers
#	integrated sendmail capability
#	sendmail functions can not be accessed w/out POP validation
#		of loginname/password


#Load POP3Client.pm module
#residing in the	Lib/mail directory of PERL.
## Note:  The previous comment was inherieted, and may differ
## depending upon the OS of your webserver.

use Mail::POP3Client;

#use the $cgi object method param() to
#acquire the FORM variables passed by
#the client browser.
&ReadParse;
$loginname = $in{'loginname'};
$password  = $in{'password'};
$POPserver = $in{'POPserver'};
$lastMsg   = $in{'lastMsg'};
$deleteMsg = $in{'deleteMsg'};
$cache     = $in{'cache'};

#if deleteMsg is not null, then this script has been called by the
#Delete Message button.  We will open a POP client object, delete
#the indicated message, then close the POP object to actually force
#the POP server to make the deletion.  The rest of the script will
#then play out and re-open the POP object.  By closing and reopening
#we will obtain an updated count that correctly does not include the
#recently deleted message.

if ($deleteMsg) {
	$pop = new Mail::POP3Client($loginname, $password, $POPserver);
	$pop->Delete($deleteMsg);
	$pop->Close();
	$deleteMsg = "";
	$pop = "";
	sleep(1);	# Gives the POP time to close and be ready for another
				# open attempt.
	}



#Begin production of HTML code.
print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>QD-POP Message Retrieval</TITLE>";

print "<SCRIPT LANGUAGE='JavaScript'>\n";
print "function closeThisWindow() { \n";
print "window.close()\n";
print "}\n";
print "</SCRIPT>\n";

if ($cache eq "No") { print "<META HTTP-EQUIV='Pragma' CONTENT='no-cache'>"; 
					  print "</HEAD>\n<BODY BGCOLOR='8FFF8F'>";
					}
else                { print "</HEAD>\n<BODY BGCOLOR='FF8F8F'>";
					}

print "<b><font size='+2'>QD-POP Message Center</font></b><hr>\n";


#Create a (possibly new) POP connection with the POP3Client object.
$pop = new Mail::POP3Client($loginname, $password, $POPserver);

#How many messages are there in the inbox provided by the $pop object?
$MessageCount = $pop->Count;


print "<table><tr><td>";
#if $pop->count is -1, then the POP connection failed.
if ($MessageCount == -1) {
    print "<font size='+1'>Either QD-POP did not connect with: <i>$POPserver</i>, or";
	print " the POP Server does not recognize the login, <i>$loginname</i>,";
	print " or password you entered...</font>";
	}
#if $pop->count is 0, there are no messages in the POP account		
elsif ($MessageCount == 0) {
        print "<b> Your Inbox on <i>$POPserver</i> is empty!</b>";
	}
#if $pop->count is >0, then that is the number of messages in the
#POP account inbox.
else {  print "<img src='/qdpop/envelop1.gif'>";
        print "<b>You have $MessageCount messages in your Inbox</b>\n";
		}

print "</td><td width=300 align=center>\n";

if ($MessageCount != -1) {	#equivalent to knowing a valid POP account was used...
	#place a button that will allow the user to create a new mail message
	#without having to "reply" to a previously received one.  This also
	#permits people to don't get much mail to be able to send something.
	print "<FORM METHOD='POST' ACTION='/cgi-shl/qdpop/makeReply.pl'>\n";
	print "<INPUT TYPE='submit'                       VALUE='New Message'>\n";
	print "<INPUT TYPE='hidden'  NAME='loginname'     VALUE=$loginname>\n";
	print "<INPUT TYPE='hidden'  NAME='password'      VALUE=$password>\n";
	print "<INPUT TYPE='hidden'  NAME='POPserver'     VALUE=$POPserver>\n";
	print "<INPUT TYPE='hidden'  NAME='cache'         VALUE=$cache>\n";
	print "<INPUT TYPE='hidden'  NAME='to'            VALUE=''>\n";
	print "<INPUT TYPE='hidden'  NAME='subject'       VALUE=''>\n";
	print "</FORM>";
	}
print "</td></tr></table>\n"; 

    
	#Parse the message headers to output a list of message
	#header info including SUBJECT,FROM,DATE,and TO.
	#each message will have a read & delete button as well
	#and these three elements will be organized in a table
		
	if ($MessageCount > 0) {
		print "<table border=1>";
        &ParseHeaders();
		print "</table>";
	
		# At the end of the form, we will place a button which can obtain 
		# more 'n' more mail messages.  Note that the button makes a "recursive"
		# call.   (In other words, it represents a perl script calling itself,
		# but with different variable values.)
		# 
		# The only value that is different is the 'lastMsg' variable
		# which is Null in the posting from the "Check Your Mail" button, but is
		# set to a non-null value on posting from this ("Get More Messages") button.
		print "<FORM METHOD='POST'  ACTION='/cgi-shl/qdpop/qdpop.pl'     >\n";
		print "<INPUT TYPE='hidden' NAME='loginname'  VALUE=$loginname   >\n";
		print "<INPUT TYPE='hidden' NAME='POPserver'  VALUE=$POPserver   >\n";
		print "<INPUT TYPE='hidden' NAME='password'   VALUE=$password    >\n";
		print "<INPUT TYPE='hidden' NAME='lastMsg'    VALUE=$i           >\n";
		print "<INPUT TYPE='hidden'  NAME='cache'     VALUE=$cache    >\n";
		print "<INPUT TYPE='submit'                   VALUE='Get More Messages'>\n";
		print "</FORM>";
		}


		# Lastly, provide a button which will let the user 'Logout'.  This 
		# actually closes the window in use in order to destroy the history log
		# which contains the all previously viewed email, plus the clear text
		# login/password/host information that would allow an intruder access
		# to the account in the future.
		print "<FORM METHOD='Post'>";
		print "<INPUT TYPE='button' VALUE='Logout' onClick='closeThisWindow()'>";
		print "</FORM>\n";


#close the POP connection smoothly.
$pop->Close;

#send the ending html code (/body and /head tags)
print "</BODY></HTML>";


#----------------------------------SUBROUTINES-------------------------


#-----------------------------Sub ParseHeaders-----------------------------
#Subroutine to parse the headers on each message to exctract the TO:, FROM:,
# DATE:, and SUBJECT: information.
#--------------------------------------------------------------------------
sub ParseHeaders {
#loop through the messages in the POP account space

#loop backwards, displaying most recent messages first
#Also note that only the most recent 100 messages will be displayed from
#

if ($lastMsg == "") { $lastMsg = $MessageCount };

for ($i=$lastMsg; $i >= 1 && $i> $lastMsg-10; $i--) {
	

	#for each message header, provide a FORM button to
	#invoke getmessage.pl and hand that routine the message
	#number. Pass the login,pass,server info again since
	#the web protocol does not provide for continued connections.
	print "<tr>\n<td align=center>";
	print "<FORM METHOD='POST'  ACTION='/cgi-shl/qdpop/getmsg.pl'    >\n";
	print "<INPUT TYPE='hidden' NAME='id'         VALUE=$i           >\n";
	print "<INPUT TYPE='hidden' NAME='loginname'  VALUE=$loginname   >\n";
	print "<INPUT TYPE='hidden' NAME='password'   VALUE=$password    >\n";
	print "<INPUT TYPE='hidden' NAME='POPserver'  VALUE=$POPserver   >\n";
	print "<INPUT TYPE='hidden' NAME='cache'      VALUE=$cache    >\n";
	print "<INPUT TYPE='submit'                   VALUE='Read $i'    >\n";
	print "</FORM></td>\n";


		$sub = '';
		$from = '';
		$to = '';
		$date = '';
		$replyto = '';
        
	#obtain each header with the head() method in POP3Client.
                        
	foreach ($pop->Head($i)){
		#for each line within the message header retrieved, parse
		#the From,To,Date,Subject fields by finding
		#the appropriate strings at the beginning
		#of each line
	if (/^From:/ ){
        	$from = $';	   		#Get string following the succesful match.
            $from =~ s/</&lt\;/;		#Strip out angled brackets to prevent browsers
            $from =~ s/>/&gt\;/;		#from interpreting them as unknown HTML codes.
            }
        elsif (/^To:/) {
			$to = $';
            }
		elsif (/^Subject:/) {
        	$sub = $';
            }
		elsif (/^Date:/) {
			$date = $';
			}
	}

	print "<td><pre>";
   	print "To:      $to\n";
    print "From:    $from\n";
	print "Subject: $sub\n";		
	print "Date:    $date";
	print "</pre></td>\n";

	#for each message header, also provide a FORM button to
	#delete using qdpop.pl As above, pass in the needed vars
	#using hidden types.
	print "<td><FORM METHOD='POST' ACTION='/cgi-shl/qdpop/qdpop.pl'     >\n";
	print     "<INPUT TYPE='hidden' NAME='loginname'  VALUE=$loginname  >\n";
	print     "<INPUT TYPE='hidden' NAME='password'   VALUE=$password   >\n";
	print     "<INPUT TYPE='hidden' NAME='POPserver'  VALUE=$POPserver  >\n";
	print     "<INPUT TYPE='hidden' NAME='deleteMsg'  VALUE=$i          >\n";
	print     "<INPUT TYPE='hidden' NAME='cache'      VALUE=$cache   >\n";
	print     "<INPUT TYPE='submit'                   VALUE='Delete $i' >\n";
	print     "</FORM></td></tr>\n";
    }
}

###############################################################################
sub ReadParse {
  local(*in)=@_ if @_;
  local ($i,$key,$val);

  if ($ENV{'REQUEST_METHOD'} eq "GET") {
    $in=$ENV{'QUERY_STRING'};
  }
  elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }
  
  @in=split(/&/,$in);
  
  foreach $i (0 .. $#in) {
    $in[$i] =~ s/\+/ /g;
    ($key,$val)=split(/=/,$in[$i],2);
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;
    $in{$key} .= "\0" if (defined($in{$key}));
    $in{$key} .=$val;
  }
  return length($in);
}
